// CirCalcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CirCalc.h"
#include "CirCalcDlg.h"
#include "stdio.h"
#include "math.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

static double WireSizes[] = {.0682,.0545,.0437,.0351,.0281,.0227,.0182,.0147,.0119,.0098,.0078};

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCirCalcDlg dialog

CCirCalcDlg::CCirCalcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCirCalcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCirCalcDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCirCalcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCirCalcDlg)
	DDX_Control(pDX, IDC_EDIT_TANK_LF, m_Edit_Tank_LF);
	DDX_Control(pDX, IDC_EDIT_TANK_L, m_Edit_Tank_L);
	DDX_Control(pDX, IDC_EDIT_TANK_HF, m_Edit_Tank_HF);
	DDX_Control(pDX, IDC_EDIT_TANK_C2, m_Edit_Tank_C2);
	DDX_Control(pDX, IDC_EDIT_TANK_C1, m_Edit_Tank_C1);
	DDX_Control(pDX, IDC_COMBO_WIRE_SIZE, m_Combo_WireSize);
	DDX_Control(pDX, IDC_EDIT_WIRE_DIA, m_Edit_WireDia);
	DDX_Control(pDX, IDC_EDIT_XL_IND, m_Edit_Xl_Ind);
	DDX_Control(pDX, IDC_EDIT_XL_FREQ, m_Edit_Xl_Freq);
	DDX_Control(pDX, IDC_EDIT_XL, m_Edit_Xl);
	DDX_Control(pDX, IDC_EDIT_XC_FREQ, m_Ecit_Xc_Freq);
	DDX_Control(pDX, IDC_EDIT_XC_CAP, m_Edit_Xc_Cap);
	DDX_Control(pDX, IDC_EDIT_XC, m_Edit_Xc);
	DDX_Control(pDX, IDC_EDIT_RES_IND, m_Edit_Res_Inductance);
	DDX_Control(pDX, IDC_EDIT_RES_FREQ, m_Edit_Res_Freq);
	DDX_Control(pDX, IDC_EDIT_RES_CAP, m_Edit_Res_Cap);
	DDX_Control(pDX, IDC_STATIC_TRUNS, m_Static_NTurns);
	DDX_Control(pDX, IDC_STATIC_STATUS, m_Static_CoilCalcStatus);
	DDX_Control(pDX, IDC_STATIC_LEN, m_Static_CoilLen);
	DDX_Control(pDX, IDC_EDIT_WIRE_SPACE, m_Edit_WireSpacing);
	DDX_Control(pDX, IDC_EDIT_DESIRED_VALUE, m_Edit_DesiredValue);
	DDX_Control(pDX, IDC_EDIT_COIL_DIA, m_Edit_CoilDia);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCirCalcDlg, CDialog)
	//{{AFX_MSG_MAP(CCirCalcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CALC_COIL_TURNS, OnButtonCalcCoilTurns)
	ON_BN_CLICKED(IDC_BUTTON_RESONANT_FREQ, OnButtonResonantFreq)
	ON_BN_CLICKED(IDC_BUTTON_CLR_IND, OnButtonClrInd)
	ON_BN_CLICKED(IDC_BUTTON_CLR_CAP, OnButtonClrCap)
	ON_BN_CLICKED(IDC_BUTTON_CLR_FREQ, OnButtonClrFreq)
	ON_BN_CLICKED(IDC_BUTTON_XL_CLR_IND, OnButtonXlClrInd)
	ON_BN_CLICKED(IDC_BUTTON_XL_CLR_FREQ, OnButtonXlClrFreq)
	ON_BN_CLICKED(IDC_BUTTON_XL_CLR, OnButtonXlClr)
	ON_BN_CLICKED(IDC_BUTTON_CALC_XL, OnButtonCalcXl)
	ON_BN_CLICKED(IDC_BUTTON_XC_CLR_CAP, OnButtonXcClrCap)
	ON_BN_CLICKED(IDC_BUTTON_XC_CLR_FREQ, OnButtonXcClrFreq)
	ON_BN_CLICKED(IDC_BUTTON_XC_CLR, OnButtonXcClr)
	ON_BN_CLICKED(IDC_BUTTON_CALC_XC, OnButtonCalcXc)
	ON_CBN_SELCHANGE(IDC_COMBO_WIRE_SIZE, OnSelchangeComboWireSize)
	ON_BN_CLICKED(IDC_BUTTON_TANK_CALC, OnButtonTankCalc)
	ON_BN_CLICKED(IDC_BUTTONT_TANK_CLR_C1, OnButtontTankClrC1)
	ON_BN_CLICKED(IDC_BUTTONT_TANK_CLR_C2, OnButtontTankClrC2)
	ON_BN_CLICKED(IDC_BUTTONT_TANK_CLR_HF, OnButtontTankClrHf)
	ON_BN_CLICKED(IDC_BUTTONT_TANK_CLR_L, OnButtontTankClrL)
	ON_BN_CLICKED(IDC_BUTTONT_TANK_CLR_LF, OnButtontTankClrLf)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCirCalcDlg message handlers

BOOL CCirCalcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{

		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	Pi = 4 * atan(1.0);

	char *s = new char[256];
	int i;

	for(i=0;i<11;++i)
	{
		sprintf(s,"#%d AWG",i*2+14);
		m_Combo_WireSize.InsertString(i,s);
	}
	m_Combo_WireSize.SetCurSel(4);
	DisplayWireSize(4);
	delete[] s;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCirCalcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCirCalcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCirCalcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCirCalcDlg::OnButtonCalcCoilTurns() 
{
	// TODO: Add your control notification handler code here
	double TurnsGuess;
	char *s = new char[256];
	double value, pitch, dia;
	double Turns;
	int iter = 0;
	double diff;

	m_Edit_DesiredValue.GetWindowText(s,256);
	value = atof(s);
	m_Edit_CoilDia.GetWindowText(s,256);
	dia = atof(s);
	m_Edit_WireSpacing.GetWindowText(s,256);
	pitch = atof(s);

	TurnsGuess = dia / pitch;
	do
	{
		Turns = CalcNTurns(dia,pitch,value,TurnsGuess);
		sprintf(s,"Turns = %d",(int)Turns);
		m_Static_NTurns.SetWindowText(s);
		sprintf(s,"Len=%6.3f",pitch * Turns);
		m_Static_CoilLen.SetWindowText(s);
		diff = Turns - TurnsGuess;
		TurnsGuess += diff;
		sprintf(s,"I=%d\nD = %6.2f",iter++,diff);
		m_Static_CoilCalcStatus.SetWindowText(s);
	}while(fabs(diff) > 0.1);

	delete[] s;
}

double CCirCalcDlg::CalcNTurns(double dia, double pitch, double value, double TurnsGuess)
{
	double rV;
	double r = dia / 2.0;

	rV = (9.0 * r + TurnsGuess * pitch * 10.0) * value / (r * r);
	rV = sqrt(rV);

	return rV;
}

void CCirCalcDlg::OnButtonResonantFreq() 
{
	// TODO: Add your control notification handler code here
	char *s	= new char [256];
	double Ind,Cap,Freq;
	int flag = 0;

	m_Edit_Res_Cap.GetWindowText(s,256);
	if(strlen(s) == 0)
		flag = 1;	//calculate capacitance
	else
		Cap = atof(s) / 1e12;
	m_Edit_Res_Inductance.GetWindowText(s,256);
	if((strlen(s) == 0) && (flag == 0))
		flag = 2;	//calculate inductance
	else if ((strlen(s) == 0) && (flag > 0))
	{
		MessageBox("More than one blank field","Error",MB_ICONHAND);
		goto exit;
	}
	else
		Ind = atof(s)/1e6;
	m_Edit_Res_Freq.GetWindowText(s,256);
	if((strlen(s) == 0) && (flag == 0))
		flag = 3;
	else if ((strlen(s) == 0) && (flag > 0))
	{
		MessageBox("More than one blank field","Error",MB_ICONHAND);
		goto exit;
	}
	else
		Freq = atof(s);

	switch(flag)
	{
		case 0:
			MessageBox("Nothing to Calculate","ERROR",MB_ICONHAND);
			break;
		case 1:	//Calculate Capacitance
			Freq = Freq * (2.0 * Pi);
			Cap = 1.0 / (Ind * Freq * Freq);
			sprintf(s,"%6.5e",Cap * 1e12);
			m_Edit_Res_Cap.SetWindowText(s);
			break;
		case 2:	//Calculate Inductance
			Freq = Freq * (2.0 * Pi);
			Ind = 1.0 / (Cap * Freq * Freq);
			sprintf(s,"%6.5e",Ind * 1e6);
			m_Edit_Res_Inductance.SetWindowText(s);
			break;
		case 3:	//Calculate Frequency
			Freq = 1.0 / (sqrt(Ind * Cap) * 2.0 * Pi);
			sprintf(s,"%8.6e",Freq);
			m_Edit_Res_Freq.SetWindowText(s);
			sprintf(s,"%6.4f",Pi);
			m_Static_CoilCalcStatus.SetWindowText(s);
			break;
	}
exit:
	delete[] s;
}

void CCirCalcDlg::OnButtonClrInd() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Res_Inductance.SetWindowText("");	
}

void CCirCalcDlg::OnButtonClrCap() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Res_Cap.SetWindowText("");
}

void CCirCalcDlg::OnButtonClrFreq() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Res_Freq.SetWindowText("");
}

void CCirCalcDlg::OnButtonXlClrInd() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Xl_Ind.SetWindowText("");
}

void CCirCalcDlg::OnButtonXlClrFreq() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Xl_Freq.SetWindowText("");	
}

void CCirCalcDlg::OnButtonXlClr() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Xl.SetWindowText("");	
}

void CCirCalcDlg::OnButtonCalcXl() 
{
	// TODO: Add your control notification handler code here
	int Flag=0;
	double Xl,F,L;
	char *s = new char[256];

	m_Edit_Xl.GetWindowText(s,256);
	if(strlen(s) == 0)
		Flag = 1;	//calculate Xc
	else
		Xl = atof(s);
	m_Edit_Xl_Ind.GetWindowText(s,256);
	if(strlen(s) == 0)
	{
		if(Flag > 0)
		{
			MessageBox("Xl:Too Many Blank Paramters","ERROR",MB_ICONHAND);
			goto exit;
		}
		else
			Flag = 2;	//calculate capacitance
	}
	else
		L = atof(s) / 1e6;	//convert uH to H
	m_Edit_Xl_Freq.GetWindowText(s,256);
	if(strlen(s) == 0)
	{
		if(Flag > 0)
		{
			MessageBox("Xc:Too Many Blank Paramters","ERROR",MB_ICONHAND);
			goto exit;
		}
		else
			Flag = 3;	//calculate frequncy
	}
	else
		F = atof(s);
	switch(Flag)
	{
		case 1:	//calcuate Xc
			Xl = 2.0 * Pi * F * L;
			sprintf(s,"%8.3e",Xl);
			m_Edit_Xl.SetWindowText(s);
			break;
		case 2:	//calcualte Capacitance
			L = Xl/ (2.0 * Pi * F);
			sprintf(s,"%8.3e",L * 1e6);	//convert H to uH
			m_Edit_Xl_Ind.SetWindowText(s);
			break;
		case 3:	//calculate Freq
			F = Xl/ (2.0 * Pi * L);
			sprintf(s,"%8.3e",F);
			m_Edit_Xl_Freq.SetWindowText(s);
			break;
	}
exit:
	delete[] s;
	
}

void CCirCalcDlg::OnButtonXcClrCap() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Xc_Cap.SetWindowText("");
}

void CCirCalcDlg::OnButtonXcClrFreq() 
{
	// TODO: Add your control notification handler code here
	m_Ecit_Xc_Freq.SetWindowText("");
	
}

void CCirCalcDlg::OnButtonXcClr() 
{
	// TODO: Add your control notification handler code here
	
	m_Edit_Xc.SetWindowText("");
}

void CCirCalcDlg::OnButtonCalcXc() 
{
	// TODO: Add your control notification handler code here
	int Flag=0;
	double Xc,F,C;
	char *s = new char[256];

	m_Edit_Xc.GetWindowText(s,256);
	if(strlen(s) == 0)
		Flag = 1;	//calculate Xc
	else
		Xc = atof(s);
	m_Edit_Xc_Cap.GetWindowText(s,256);
	if(strlen(s) == 0)
	{
		if(Flag > 0)
		{
			MessageBox("Xc:Too Many Blank Paramters","ERROR",MB_ICONHAND);
			goto exit;
		}
		else
			Flag = 2;	//calculate capacitance
	}
	else
		C = atof(s) / (1e12);	//convert pf to farads
	m_Ecit_Xc_Freq.GetWindowText(s,256);
	if(strlen(s) == 0)
	{
		if(Flag > 0)
		{
			MessageBox("Xc:Too Many Blank Paramters","ERROR",MB_ICONHAND);
			goto exit;
		}
		else
			Flag = 3;	//calculate frequncy
	}
	else
		F = atof(s);
	switch(Flag)
	{
		case 1:	//calcuate Xc
			Xc = 1/ (2.0 * Pi * F * C);
			sprintf(s,"%8.3e",Xc);
			m_Edit_Xc.SetWindowText(s);
			break;
		case 2:	//calcualte Capacitance
			C = 1.0/ (2.0 * Pi * F * Xc);
			sprintf(s,"%8.3e",C * 1e12);	//convert farads to pf
			m_Edit_Xc_Cap.SetWindowText(s);
			break;
		case 3:	//calculate Freq
			F = 1.0/ (2.0 * Pi * C * Xc);
			sprintf(s,"%8.3e",F);
			m_Ecit_Xc_Freq.SetWindowText(s);
			break;
	}
exit:
	delete[] s;
}

void CCirCalcDlg::DisplayWireSize(int Sel)
{
	char *s = new char[256];
	sprintf(s,"%6.4lf",WireSizes[Sel]);
	m_Edit_WireDia.SetWindowText(s);
	delete [] s;
}

void CCirCalcDlg::OnSelchangeComboWireSize() 
{
	// TODO: Add your control notification handler code here
	DisplayWireSize(m_Combo_WireSize.GetCurSel());
}

void CCirCalcDlg::OnButtonTankCalc() 
{
	// TODO: Add your control notification handler code here
	//--------------------------------
	// We need to solve for two of the
	// quantities.
	// They will be C2 and L
	//--------------------------------
	double L,C1,C2,LF,HF;

	char *s = new char [256];
	m_Edit_Tank_LF.GetWindowText(s,255);
	LF = atof(s);
	m_Edit_Tank_HF.GetWindowText(s,255);
	HF = atof(s);
	m_Edit_Tank_C1.GetWindowText(s,255);
	C1 = atof(s) * 1.0e-12;

	L = ((1.0 / ((2 * Pi * LF) * (2 * Pi * LF))) - (1.0 / ((2 * Pi * HF) * (2 * Pi * HF)))) / C1;
	sprintf(s,"%6f",L*1.0e6);
	m_Edit_Tank_L.SetWindowText(s);

	C2 = 1.0 / ( (2 * Pi * HF) * (2 * Pi * HF) * L);
	sprintf(s,"%6f",C2 * 1.0e12);
	m_Edit_Tank_C2.SetWindowText(s);
	delete[] s;
}

void CCirCalcDlg::OnButtontTankClrC1() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Tank_C1.SetWindowText("");
}

void CCirCalcDlg::OnButtontTankClrC2() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Tank_C2.SetWindowText("");

}

void CCirCalcDlg::OnButtontTankClrHf() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Tank_HF.SetWindowText("");
}

void CCirCalcDlg::OnButtontTankClrL() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Tank_L.SetWindowText("");
}

void CCirCalcDlg::OnButtontTankClrLf() 
{
	// TODO: Add your control notification handler code here
	m_Edit_Tank_LF.SetWindowText("");
}
