// CirCalcDlg.h : header file
//

#if !defined(AFX_CIRCALCDLG_H__3ED58426_8E49_4FEA_A7EA_882CA6F0F83D__INCLUDED_)
#define AFX_CIRCALCDLG_H__3ED58426_8E49_4FEA_A7EA_882CA6F0F83D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCirCalcDlg dialog

class CCirCalcDlg : public CDialog
{
// Construction
public:
	void DisplayWireSize(int Sel);
	double Pi;
	double CalcNTurns(double dia, double pitch,double value, double TurnsGuess);
	CCirCalcDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CCirCalcDlg)
	enum { IDD = IDD_CIRCALC_DIALOG };
	CEdit	m_Edit_Tank_LF;
	CEdit	m_Edit_Tank_L;
	CEdit	m_Edit_Tank_HF;
	CEdit	m_Edit_Tank_C2;
	CEdit	m_Edit_Tank_C1;
	CComboBox	m_Combo_WireSize;
	CEdit	m_Edit_WireDia;
	CEdit	m_Edit_Xl_Ind;
	CEdit	m_Edit_Xl_Freq;
	CEdit	m_Edit_Xl;
	CEdit	m_Ecit_Xc_Freq;
	CEdit	m_Edit_Xc_Cap;
	CEdit	m_Edit_Xc;
	CEdit	m_Edit_Res_Inductance;
	CEdit	m_Edit_Res_Freq;
	CEdit	m_Edit_Res_Cap;
	CStatic	m_Static_NTurns;
	CStatic	m_Static_CoilCalcStatus;
	CStatic	m_Static_CoilLen;
	CEdit	m_Edit_WireSpacing;
	CEdit	m_Edit_DesiredValue;
	CEdit	m_Edit_CoilDia;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCirCalcDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CCirCalcDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonCalcCoilTurns();
	afx_msg void OnButtonResonantFreq();
	afx_msg void OnButtonClrInd();
	afx_msg void OnButtonClrCap();
	afx_msg void OnButtonClrFreq();
	afx_msg void OnButtonXlClrInd();
	afx_msg void OnButtonXlClrFreq();
	afx_msg void OnButtonXlClr();
	afx_msg void OnButtonCalcXl();
	afx_msg void OnButtonXcClrCap();
	afx_msg void OnButtonXcClrFreq();
	afx_msg void OnButtonXcClr();
	afx_msg void OnButtonCalcXc();
	afx_msg void OnSelchangeComboWireSize();
	afx_msg void OnButtonTankCalc();
	afx_msg void OnButtontTankClrC1();
	afx_msg void OnButtontTankClrC2();
	afx_msg void OnButtontTankClrHf();
	afx_msg void OnButtontTankClrL();
	afx_msg void OnButtontTankClrLf();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CIRCALCDLG_H__3ED58426_8E49_4FEA_A7EA_882CA6F0F83D__INCLUDED_)
